Index: pjproject/trunk/pjlib-util/src/pjlib-util/stun_msg.c
===================================================================
--- pjproject/trunk/pjlib-util/src/pjlib-util/stun_msg.c	(revision 1036)
+++ pjproject/trunk/pjlib-util/src/pjlib-util/stun_msg.c	(revision 1037)
@@ -2031,289 +2057,2 @@
 }
 
-
-/**************************************************************************/
-/*
- * Authentication
- */
-
-
-/* Send 401 response */
-static pj_status_t create_challenge(pj_pool_t *pool,
-				    const pj_stun_msg *msg,
-				    int err_code,
-				    const pj_str_t *err_msg,
-				    const pj_str_t *realm,
-				    const pj_str_t *nonce,
-				    pj_stun_msg **p_response)
-{
-    pj_stun_msg *response;
-    pj_status_t rc;
-
-    rc = pj_stun_msg_create_response(pool, msg, 
-				     err_code,  err_msg, &response);
-    if (rc != PJ_SUCCESS)
-	return rc;
-
-
-    if (realm && realm->slen) {
-	rc = pj_stun_msg_add_generic_string_attr(pool, response,
-						 PJ_STUN_ATTR_REALM, 
-						 realm);
-	if (rc != PJ_SUCCESS)
-	    return rc;
-    }
-
-    if (nonce && nonce->slen) {
-	rc = pj_stun_msg_add_generic_string_attr(pool, response,
-						 PJ_STUN_ATTR_NONCE, 
-						 nonce);
-	if (rc != PJ_SUCCESS)
-	    return rc;
-    }
-
-    *p_response = response;
-
-    return PJ_SUCCESS;
-}
-
-/* Verify credential */
-PJ_DEF(pj_status_t) pj_stun_verify_credential( const pj_uint8_t *pkt,
-					       unsigned pkt_len,
-					       const pj_stun_msg *msg,
-					       pj_stun_auth_policy *pol,
-					       pj_pool_t *pool,
-					       pj_stun_msg **p_response)
-{
-    pj_str_t realm, nonce, password;
-    const pj_stun_msg_integrity_attr *amsgi;
-    unsigned amsgi_pos;
-    const pj_stun_username_attr *auser;
-    pj_bool_t username_ok;
-    const pj_stun_realm_attr *arealm;
-    const pj_stun_realm_attr *anonce;
-    pj_uint8_t digest[PJ_SHA1_DIGEST_SIZE];
-    pj_uint8_t md5_digest[16];
-    pj_str_t key;
-    pj_status_t status;
-
-    /* msg and policy MUST be specified */
-    PJ_ASSERT_RETURN(pkt && pkt_len && msg && pol, PJ_EINVAL);
-
-    /* If p_response is specified, pool MUST be specified. */
-    PJ_ASSERT_RETURN(!p_response || pool, PJ_EINVAL);
-
-    if (p_response)
-	*p_response = NULL;
-
-    if (!PJ_STUN_IS_REQUEST(msg->hdr.type))
-	p_response = NULL;
-
-    /* Get realm and nonce */
-    realm.slen = nonce.slen = 0;
-    if (pol->type == PJ_STUN_POLICY_STATIC_SHORT_TERM) {
-	realm.slen = 0;
-	nonce = pol->data.static_short_term.nonce;
-    } else if (pol->type == PJ_STUN_POLICY_STATIC_LONG_TERM) {
-	realm = pol->data.static_long_term.realm;
-	nonce = pol->data.static_long_term.nonce;
-    } else if (pol->type == PJ_STUN_POLICY_DYNAMIC) {
-	status = pol->data.dynamic.get_auth(pol->user_data, pool, 
-					    &realm, &nonce);
-	if (status != PJ_SUCCESS)
-	    return status;
-    } else {
-	pj_assert(!"Unexpected");
-	return PJ_EBUG;
-    }
-
-    /* First check that MESSAGE-INTEGRITY is present */
-    amsgi = (const pj_stun_msg_integrity_attr*)
-	    pj_stun_msg_find_attr(msg, PJ_STUN_ATTR_MESSAGE_INTEGRITY, 0);
-    if (amsgi == NULL) {
-	if (p_response) {
-	    create_challenge(pool, msg, PJ_STUN_STATUS_UNAUTHORIZED, NULL,
-			     &realm, &nonce, p_response);
-	}
-	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_STATUS_UNAUTHORIZED);
-    }
-
-    /* Next check that USERNAME is present */
-    auser = (const pj_stun_username_attr*)
-	    pj_stun_msg_find_attr(msg, PJ_STUN_ATTR_USERNAME, 0);
-    if (auser == NULL) {
-	if (p_response) {
-	    create_challenge(pool, msg, PJ_STUN_STATUS_MISSING_USERNAME, NULL,
-			     &realm, &nonce, p_response);
-	}
-	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_STATUS_MISSING_USERNAME);
-    }
-
-    /* Get REALM, if any */
-    arealm = (const pj_stun_realm_attr*)
-	     pj_stun_msg_find_attr(msg, PJ_STUN_ATTR_REALM, 0);
-
-    /* Check if username match */
-    if (pol->type == PJ_STUN_POLICY_STATIC_SHORT_TERM) {
-	username_ok = !pj_strcmp(&auser->value, 
-				 &pol->data.static_short_term.username);
-	password = pol->data.static_short_term.password;
-    } else if (pol->type == PJ_STUN_POLICY_STATIC_LONG_TERM) {
-	username_ok = !pj_strcmp(&auser->value, 
-				 &pol->data.static_long_term.username);
-	password = pol->data.static_long_term.password;
-    } else if (pol->type == PJ_STUN_POLICY_DYNAMIC) {
-	pj_status_t rc;
-	rc = pol->data.dynamic.get_password(pol->user_data, 
-					    (arealm?&arealm->value:NULL),
-					    &auser->value, pool,
-					    &password);
-	username_ok = (rc == PJ_SUCCESS);
-    } else {
-	username_ok = PJ_TRUE;
-	password.slen = 0;
-    }
-
-    if (!username_ok) {
-	/* Username mismatch */
-	if (p_response) {
-	    create_challenge(pool, msg, PJ_STUN_STATUS_UNKNOWN_USERNAME, NULL,
-			     &realm, &nonce, p_response);
-	}
-	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_STATUS_UNKNOWN_USERNAME);
-    }
-
-
-    /* Get NONCE attribute */
-    anonce = (pj_stun_nonce_attr*)
-	     pj_stun_msg_find_attr(msg, PJ_STUN_ATTR_NONCE, 0);
-
-    /* Check for long term/short term requirements. */
-    if (realm.slen != 0 && arealm == NULL) {
-	/* Long term credential is required and REALM is not present */
-	if (p_response) {
-	    create_challenge(pool, msg, PJ_STUN_STATUS_MISSING_REALM, NULL,
-			     &realm, &nonce, p_response);
-	}
-	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_STATUS_MISSING_REALM);
-
-    } else if (realm.slen != 0 && arealm != NULL) {
-	/* We want long term, and REALM is present */
-
-	/* NONCE must be present. */
-	if (anonce == NULL) {
-	    if (p_response) {
-		create_challenge(pool, msg, PJ_STUN_STATUS_MISSING_NONCE, 
-				 NULL, &realm, &nonce, p_response);
-	    }
-	    return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_STATUS_MISSING_NONCE);
-	}
-
-	/* Verify REALM matches */
-	if (pj_stricmp(&arealm->value, &realm)) {
-	    /* REALM doesn't match */
-	    if (p_response) {
-		create_challenge(pool, msg, PJ_STUN_STATUS_MISSING_REALM, 
-				 NULL, &realm, &nonce, p_response);
-	    }
-	    return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_STATUS_MISSING_REALM);
-	}
-
-	/* Valid case, will validate the message integrity later */
-
-    } else if (realm.slen == 0 && arealm != NULL) {
-	/* We want to use short term credential, but client uses long
-	 * term credential. The draft doesn't mention anything about
-	 * switching between long term and short term.
-	 */
-	
-	/* For now just accept the credential, anyway it will probably
-	 * cause wrong message integrity value later.
-	 */
-    } else if (realm.slen==0 && arealm == NULL) {
-	/* Short term authentication is wanted, and one is supplied */
-
-	/* Application MAY request NONCE to be supplied */
-	if (nonce.slen != 0) {
-	    if (p_response) {
-		create_challenge(pool, msg, PJ_STUN_STATUS_MISSING_NONCE, 
-				 NULL, &realm, &nonce, p_response);
-	    }
-	    return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_STATUS_MISSING_NONCE);
-	}
-    }
-
-    /* If NONCE is present, validate it */
-    if (anonce) {
-	pj_bool_t ok;
-
-	if (pol->type == PJ_STUN_POLICY_DYNAMIC) {
-	    ok = pol->data.dynamic.verify_nonce(pol->user_data,
-						(arealm?&arealm->value:NULL),
-						&auser->value,
-						&anonce->value);
-	} else {
-	    if (nonce.slen) {
-		ok = !pj_strcmp(&anonce->value, &nonce);
-	    } else {
-		ok = PJ_TRUE;
-	    }
-	}
-
-	if (!ok) {
-	    if (p_response) {
-		create_challenge(pool, msg, PJ_STUN_STATUS_STALE_NONCE, 
-				 NULL, &realm, &nonce, p_response);
-	    }
-	    return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_STATUS_STALE_NONCE);
-	}
-    }
-
-    /* Get the position of MESSAGE-INTEGRITY in the packet */
-    amsgi_pos = 20+msg->hdr.length-22;
-    if (GET_VAL16(pkt, amsgi_pos) == PJ_STUN_ATTR_MESSAGE_INTEGRITY) {
-	/* Found MESSAGE-INTEGRITY as the last attribute */
-    } else {
-	amsgi_pos = 0;
-    }
-    
-    if (amsgi_pos==0) {
-	amsgi_pos = 20+msg->hdr.length-8-22;
-	if (GET_VAL16(pkt, amsgi_pos) == PJ_STUN_ATTR_MESSAGE_INTEGRITY) {
-	    /* Found MESSAGE-INTEGRITY before FINGERPRINT */
-	} else {
-	    amsgi_pos = 0;
-	}
-    }
-
-    if (amsgi_pos==0) {
-	pj_assert(!"Unable to find MESSAGE-INTEGRITY in the message!");
-	return PJ_EBUG;
-    }
-
-    /* Determine which key to use */
-    if (realm.slen) {
-	calc_md5_key(md5_digest, &realm, &auser->value, &password);
-	key.ptr = (char*)md5_digest;
-	key.slen = 16;
-    } else {
-	key = password;
-    }
-
-    /* Now calculate HMAC of the message */
-    pj_hmac_sha1(pkt, amsgi_pos, (pj_uint8_t*)key.ptr, key.slen, digest);
-
-    /* Compare HMACs */
-    if (pj_memcmp(amsgi->hmac, digest, 20)) {
-	/* HMAC value mismatch */
-	if (p_response) {
-	    create_challenge(pool, msg, PJ_STUN_STATUS_INTEGRITY_CHECK_FAILURE,
-			     NULL, &realm, &nonce, p_response);
-	}
-	return PJ_STATUS_FROM_STUN_CODE(PJ_STUN_STATUS_INTEGRITY_CHECK_FAILURE);
-    }
-
-    /* Everything looks okay! */
-    return PJ_SUCCESS;
-}
-
-
Index: pjproject/trunk/pjlib-util/src/pjlib-util/stun_msg_dump.c
===================================================================
--- pjproject/trunk/pjlib-util/src/pjlib-util/stun_msg_dump.c	(revision 1036)
+++ pjproject/trunk/pjlib-util/src/pjlib-util/stun_msg_dump.c	(revision 1037)
@@ -54,7 +54,7 @@
     case PJ_STUN_ATTR_ALTERNATE_SERVER:
 	{
-	    const pj_stun_generic_ip_addr_attr *attr;
-
-	    attr = (const pj_stun_generic_ip_addr_attr*)ahdr;
+	    const pj_stun_ip_addr_attr *attr;
+
+	    attr = (const pj_stun_ip_addr_attr*)ahdr;
 
 	    if (attr->addr.addr.sa_family == PJ_AF_INET) {
@@ -85,7 +85,7 @@
     case PJ_STUN_ATTR_REFRESH_INTERVAL:
 	{
-	    const pj_stun_generic_uint_attr *attr;
-
-	    attr = (const pj_stun_generic_uint_attr*)ahdr;
+	    const pj_stun_uint_attr *attr;
+
+	    attr = (const pj_stun_uint_attr*)ahdr;
 	    len = pj_ansi_snprintf(p, end-p,
 				   ", value=%d (0x%x)\n",
@@ -101,7 +101,7 @@
     case PJ_STUN_ATTR_SERVER:
 	{
-	    const pj_stun_generic_string_attr *attr;
-
-	    attr = (pj_stun_generic_string_attr*)ahdr;
+	    const pj_stun_string_attr *attr;
+
+	    attr = (pj_stun_string_attr*)ahdr;
 	    len = pj_ansi_snprintf(p, end-p,
 				   ", value=\"%.*s\"\n",
@@ -113,7 +113,7 @@
     case PJ_STUN_ATTR_ERROR_CODE:
 	{
-	    const pj_stun_error_code_attr *attr;
-
-	    attr = (const pj_stun_error_code_attr*) ahdr;
+	    const pj_stun_errcode_attr *attr;
+
+	    attr = (const pj_stun_errcode_attr*) ahdr;
 	    len = pj_ansi_snprintf(p, end-p,
 				   ", err_code=%d, reason=\"%.*s\"\n",
Index: pjproject/trunk/pjlib-util/src/pjlib-util/stun_session.c
===================================================================
--- pjproject/trunk/pjlib-util/src/pjlib-util/stun_session.c	(revision 1036)
+++ pjproject/trunk/pjlib-util/src/pjlib-util/stun_session.c	(revision 1037)
@@ -28,12 +28,7 @@
     void		*user_data;
 
-    /* Long term credential */
-    pj_str_t		 l_realm;
-    pj_str_t		 l_username;
-    pj_str_t		 l_password;
-
-    /* Short term credential */
-    pj_str_t		 s_username;
-    pj_str_t		 s_password;
+    pj_bool_t		 use_fingerprint;
+    pj_stun_auth_cred	*cred;
+    pj_str_t		 srv_name;
 
     pj_stun_tx_data	 pending_request_list;
@@ -214,86 +209,63 @@
 }
 
+static pj_str_t *get_passwd(pj_stun_session *sess)
+{
+    if (sess->cred == NULL)
+	return NULL;
+    else if (sess->cred->type == PJ_STUN_AUTH_CRED_STATIC)
+	return &sess->cred->data.static_cred.data;
+    else
+	return NULL;
+}
+
 static pj_status_t apply_msg_options(pj_stun_session *sess,
 				     pj_pool_t *pool,
-				     unsigned options,
-				     pj_stun_msg *msg,
-				     pj_str_t **p_passwd)
-{
-    pj_status_t status;
+				     pj_stun_msg *msg)
+{
+    pj_status_t status = 0;
+
+    /* The server SHOULD include a SERVER attribute in all responses */
+    if (PJ_STUN_IS_RESPONSE(msg->hdr.type) ||
+	PJ_STUN_IS_ERROR_RESPONSE(msg->hdr.type)) 
+    {
+	pj_stun_msg_add_string_attr(pool, msg, PJ_STUN_ATTR_SERVER,
+				    &sess->srv_name);
+    }
 
     /* From draft-ietf-behave-rfc3489bis-05.txt
      * Section 8.3.1.  Formulating the Request Message
+     *
+     * Note: only put MESSAGE-INTEGRITY in non error response.
      */
-    if (options & PJ_STUN_USE_LONG_TERM_CRED) {
-	pj_stun_generic_string_attr *auname;
-	pj_stun_msg_integrity_attr *amsgi;
-	pj_stun_generic_string_attr *arealm;
-
-	*p_passwd = &sess->l_password;
+    if (sess->cred && sess->cred->type == PJ_STUN_AUTH_CRED_STATIC &&
+	!PJ_STUN_IS_ERROR_RESPONSE(msg->hdr.type)) 
+    {
+	const pj_str_t *username;
 
 	/* Create and add USERNAME attribute */
-	status = pj_stun_generic_string_attr_create(pool, 
-						    PJ_STUN_ATTR_USERNAME,
-						    &sess->l_username,
-						    &auname);
+	username = &sess->cred->data.static_cred.username;
+	status = pj_stun_msg_add_string_attr(pool, msg,
+					     PJ_STUN_ATTR_USERNAME,
+					     username);
 	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
 
-	status = pj_stun_msg_add_attr(msg, &auname->hdr);
+	/* Add REALM only when long term credential is used */
+	if (sess->cred->data.static_cred.realm.slen) {
+	    const pj_str_t *realm = &sess->cred->data.static_cred.realm;
+	    status = pj_stun_msg_add_string_attr(pool, msg,
+						PJ_STUN_ATTR_REALM,
+						realm);
+	}
+
+	/* Add MESSAGE-INTEGRITY attribute */
+	status = pj_stun_msg_add_msgint_attr(pool, msg);
 	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
 
-	/* Add REALM only when long term credential is used */
-	status = pj_stun_generic_string_attr_create(pool, 
-						    PJ_STUN_ATTR_REALM,
-						    &sess->l_realm,
-						    &arealm);
-	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
-
-	status = pj_stun_msg_add_attr(msg, &arealm->hdr);
-	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
-
-	/* Add MESSAGE-INTEGRITY attribute */
-	status = pj_stun_msg_integrity_attr_create(pool, &amsgi);
-	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
-
-	status = pj_stun_msg_add_attr(msg, &amsgi->hdr);
-	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
-
-    } else if (options & PJ_STUN_USE_SHORT_TERM_CRED) {
-	pj_stun_generic_string_attr *auname;
-	pj_stun_msg_integrity_attr *amsgi;
-
-	*p_passwd = &sess->s_password;
-
-	/* Create and add USERNAME attribute */
-	status = pj_stun_generic_string_attr_create(pool, 
-						    PJ_STUN_ATTR_USERNAME,
-						    &sess->s_username,
-						    &auname);
-	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
-
-	status = pj_stun_msg_add_attr(msg, &auname->hdr);
-	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
-
-	/* Add MESSAGE-INTEGRITY attribute */
-	status = pj_stun_msg_integrity_attr_create(pool, &amsgi);
-	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
-
-	status = pj_stun_msg_add_attr(msg, &amsgi->hdr);
-	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
-
-    } else {
-	*p_passwd = NULL;
-    }
+    } 
 
     /* Add FINGERPRINT attribute if necessary */
-    if (options & PJ_STUN_USE_FINGERPRINT) {
-	pj_stun_fingerprint_attr *af;
-
-	status = pj_stun_generic_uint_attr_create(pool, 
-						  PJ_STUN_ATTR_FINGERPRINT,
-						  0, &af);
-	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
-
-	status = pj_stun_msg_add_attr(msg, &af->hdr);
+    if (sess->use_fingerprint) {
+	status = pj_stun_msg_add_uint_attr(pool, msg, 
+					  PJ_STUN_ATTR_FINGERPRINT, 0);
 	PJ_ASSERT_RETURN(status==PJ_SUCCESS, status);
     }
@@ -334,4 +306,5 @@
 					    const char *name,
 					    const pj_stun_session_cb *cb,
+					    pj_bool_t fingerprint,
 					    pj_stun_session **p_sess)
 {
@@ -352,4 +325,9 @@
     sess->pool = pool;
     pj_memcpy(&sess->cb, cb, sizeof(*cb));
+    sess->use_fingerprint = fingerprint;
+    
+    sess->srv_name.ptr = pj_pool_alloc(pool, 32);
+    sess->srv_name.slen = pj_ansi_snprintf(sess->srv_name.ptr, 32,
+					   "pj_stun-%s", PJ_VERSION);
 
     pj_list_init(&sess->pending_request_list);
@@ -394,39 +372,23 @@
 }
 
-PJ_DEF(pj_status_t) 
-pj_stun_session_set_long_term_credential(pj_stun_session *sess,
-					 const pj_str_t *realm,
-					 const pj_str_t *user,
-					 const pj_str_t *passwd)
-{
-    pj_str_t nil = { NULL, 0 };
-
-    PJ_ASSERT_RETURN(sess, PJ_EINVAL);
-
-    pj_mutex_lock(sess->mutex);
-    pj_strdup_with_null(sess->pool, &sess->l_realm, realm ? realm : &nil);
-    pj_strdup_with_null(sess->pool, &sess->l_username, user ? user : &nil);
-    pj_strdup_with_null(sess->pool, &sess->l_password, passwd ? passwd : &nil);
-    pj_mutex_unlock(sess->mutex);
-
-    return PJ_SUCCESS;
-}
-
-
-PJ_DEF(pj_status_t) 
-pj_stun_session_set_short_term_credential(pj_stun_session *sess,
-					  const pj_str_t *user,
-					  const pj_str_t *passwd)
-{
-    pj_str_t nil = { NULL, 0 };
-
-    PJ_ASSERT_RETURN(sess, PJ_EINVAL);
-
-    pj_mutex_lock(sess->mutex);
-    pj_strdup_with_null(sess->pool, &sess->s_username, user ? user : &nil);
-    pj_strdup_with_null(sess->pool, &sess->s_password, passwd ? passwd : &nil);
-    pj_mutex_unlock(sess->mutex);
-
-    return PJ_SUCCESS;
+PJ_DEF(pj_status_t) pj_stun_session_set_server_name(pj_stun_session *sess,
+						    const pj_str_t *srv_name)
+{
+    PJ_ASSERT_RETURN(sess && srv_name, PJ_EINVAL);
+    pj_strdup(sess->pool, &sess->srv_name, srv_name);
+    return PJ_SUCCESS;
+}
+
+PJ_DEF(void) pj_stun_session_set_credential(pj_stun_session *sess,
+					    const pj_stun_auth_cred *cred)
+{
+    PJ_ASSERT_ON_FAIL(sess, return);
+    if (cred) {
+	if (!sess->cred)
+	    sess->cred = pj_pool_alloc(sess->pool, sizeof(pj_stun_auth_cred));
+	pj_stun_auth_cred_dup(sess->pool, sess->cred, cred);
+    } else {
+	sess->cred = NULL;
+    }
 }
 
@@ -570,15 +532,12 @@
 
 PJ_DEF(pj_status_t) pj_stun_session_send_msg( pj_stun_session *sess,
-					      unsigned options,
+					      pj_bool_t cache_res,
 					      const pj_sockaddr_t *server,
 					      unsigned addr_len,
 					      pj_stun_tx_data *tdata)
 {
-    pj_str_t *password;
     pj_status_t status;
 
     PJ_ASSERT_RETURN(sess && addr_len && server && tdata, PJ_EINVAL);
-
-    tdata->options = options;
 
     /* Allocate packet */
@@ -590,6 +549,5 @@
 
     /* Apply options */
-    status = apply_msg_options(sess, tdata->pool, options, 
-			       tdata->msg, &password);
+    status = apply_msg_options(sess, tdata->pool, tdata->msg);
     if (status != PJ_SUCCESS) {
 	pj_stun_msg_destroy_tdata(sess, tdata);
@@ -601,5 +559,5 @@
     /* Encode message */
     status = pj_stun_msg_encode(tdata->msg, tdata->pkt, tdata->max_len,
-			        0, password, &tdata->pkt_size);
+			        0, get_passwd(sess), &tdata->pkt_size);
     if (status != PJ_SUCCESS) {
 	pj_stun_msg_destroy_tdata(sess, tdata);
@@ -641,5 +599,5 @@
 
     } else {
-	if ((options & PJ_STUN_CACHE_RESPONSE) && 
+	if (cache_res && 
 	    (PJ_STUN_IS_RESPONSE(tdata->msg->hdr.type) ||
 	     PJ_STUN_IS_ERROR_RESPONSE(tdata->msg->hdr.type))) 
@@ -688,4 +646,66 @@
 
 
+/* Send response */
+static pj_status_t send_response(pj_stun_session *sess, 
+				 pj_pool_t *pool, pj_stun_msg *response,
+				 pj_bool_t retransmission,
+				 const pj_sockaddr_t *addr, unsigned addr_len)
+{
+    pj_uint8_t *out_pkt;
+    unsigned out_max_len, out_len;
+    pj_status_t status;
+
+    /* Alloc packet buffer */
+    out_max_len = PJ_STUN_MAX_PKT_LEN;
+    out_pkt = pj_pool_alloc(pool, out_max_len);
+
+    /* Apply options */
+    if (!retransmission) {
+	apply_msg_options(sess, pool, response);
+    }
+
+    /* Encode */
+    status = pj_stun_msg_encode(response, out_pkt, out_max_len, 0, 
+				get_passwd(sess), &out_len);
+    if (status != PJ_SUCCESS) {
+	LOG_ERR_(sess, "Error encoding message", status);
+	return status;
+    }
+
+    /* Print log */
+    dump_tx_msg(sess, response, out_len, addr);
+
+    /* Send packet */
+    status = sess->cb.on_send_msg(sess, out_pkt, out_len, addr, addr_len);
+
+    return status;
+}
+
+/* Authenticate incoming message */
+static pj_status_t authenticate_msg(pj_stun_session *sess,
+				    const pj_uint8_t *pkt,
+				    unsigned pkt_len,
+				    const pj_stun_msg *msg,
+				    pj_pool_t *tmp_pool,
+				    const pj_sockaddr_t *src_addr,
+				    unsigned src_addr_len)
+{
+    pj_stun_msg *response;
+    pj_status_t status;
+
+    if (PJ_STUN_IS_ERROR_RESPONSE(msg->hdr.type) || sess->cred == NULL)
+	return PJ_SUCCESS;
+
+    status = pj_stun_verify_credential(pkt, pkt_len, msg, sess->cred,
+				       tmp_pool, &response);
+    if (status != PJ_SUCCESS && response != NULL) {
+	send_response(sess, tmp_pool, response, PJ_FALSE, 
+		      src_addr, src_addr_len);
+    }
+
+    return status;
+}
+
+
 /* Handle incoming response */
 static pj_status_t on_incoming_response(pj_stun_session *sess,
@@ -724,49 +744,12 @@
 
 
-/* Send response */
-static pj_status_t send_response(pj_stun_session *sess, unsigned options,
-				 pj_pool_t *pool, pj_stun_msg *response,
-				 const pj_sockaddr_t *addr, unsigned addr_len)
-{
-    pj_uint8_t *out_pkt;
-    unsigned out_max_len, out_len;
-    pj_str_t *passwd;
-    pj_status_t status;
-
-    /* Alloc packet buffer */
-    out_max_len = PJ_STUN_MAX_PKT_LEN;
-    out_pkt = pj_pool_alloc(pool, out_max_len);
-
-    /* Apply options */
-    apply_msg_options(sess, pool, options, response, &passwd);
-
-    /* Encode */
-    status = pj_stun_msg_encode(response, out_pkt, out_max_len, 0, 
-				passwd, &out_len);
-    if (status != PJ_SUCCESS) {
-	LOG_ERR_(sess, "Error encoding message", status);
-	return status;
-    }
-
-    /* Print log */
-    dump_tx_msg(sess, response, out_len, addr);
-
-    /* Send packet */
-    status = sess->cb.on_send_msg(sess, out_pkt, out_len, addr, addr_len);
-
-    return status;
-}
-
-/* Handle incoming request */
-static pj_status_t on_incoming_request(pj_stun_session *sess,
-				       pj_pool_t *tmp_pool,
-				       const pj_uint8_t *in_pkt,
-				       unsigned in_pkt_len,
-				       const pj_stun_msg *msg,
-				       const pj_sockaddr_t *src_addr,
-				       unsigned src_addr_len)
+/* For requests, check if we cache the response */
+static pj_status_t check_cached_response(pj_stun_session *sess,
+					 pj_pool_t *tmp_pool,
+					 const pj_stun_msg *msg,
+					 const pj_sockaddr_t *src_addr,
+					 unsigned src_addr_len)
 {
     pj_stun_tx_data *t;
-    pj_status_t status;
 
     /* First lookup response in response cache */
@@ -784,14 +767,26 @@
     if (t != &sess->cached_response_list) {
 	/* Found response in the cache */
-	unsigned options;
 
 	PJ_LOG(5,(SNAME(sess), 
 		 "Request retransmission, sending cached response"));
 
-	options = t->options;
-	options &= ~PJ_STUN_CACHE_RESPONSE;
-	pj_stun_session_send_msg(sess, options, src_addr, src_addr_len, t);
+	send_response(sess, tmp_pool, t->msg, PJ_TRUE, 
+		      src_addr, src_addr_len);
 	return PJ_SUCCESS;
     }
+
+    return PJ_ENOTFOUND;
+}
+
+/* Handle incoming request */
+static pj_status_t on_incoming_request(pj_stun_session *sess,
+				       pj_pool_t *tmp_pool,
+				       const pj_uint8_t *in_pkt,
+				       unsigned in_pkt_len,
+				       const pj_stun_msg *msg,
+				       const pj_sockaddr_t *src_addr,
+				       unsigned src_addr_len)
+{
+    pj_status_t status;
 
     /* Distribute to handler, or respond with Bad Request */
@@ -800,5 +795,5 @@
 					   src_addr, src_addr_len);
     } else {
-	pj_stun_msg *response = NULL;
+	pj_stun_msg *response;
 
 	status = pj_stun_msg_create_response(tmp_pool, msg, 
@@ -806,6 +801,6 @@
 					     &response);
 	if (status == PJ_SUCCESS && response) {
-	    status = send_response(sess, 0, tmp_pool, response, 
-				   src_addr, src_addr_len);
+	    status = send_response(sess, tmp_pool, response, 
+				   PJ_FALSE, src_addr, src_addr_len);
 	}
     }
@@ -862,6 +857,6 @@
 	LOG_ERR_(sess, "STUN msg_decode() error", status);
 	if (response) {
-	    send_response(sess, 0, tmp_pool, response, 
-			  src_addr, src_addr_len);
+	    send_response(sess, tmp_pool, response, 
+			  PJ_FALSE, src_addr, src_addr_len);
 	}
 	pj_pool_release(tmp_pool);
@@ -880,4 +875,18 @@
     pj_mutex_lock(sess->mutex);
 
+    /* For requests, check if we have cached response */
+    status = check_cached_response(sess, tmp_pool, msg, 
+				   src_addr, src_addr_len);
+    if (status == PJ_SUCCESS) {
+	goto on_return;
+    }
+
+    /* Authenticate the message */
+    status = authenticate_msg(sess, packet, pkt_size, msg, tmp_pool, 
+			      src_addr, src_addr_len);
+    if (status != PJ_SUCCESS)
+	goto on_return;
+
+    /* Handle message */
     if (PJ_STUN_IS_RESPONSE(msg->hdr.type) ||
 	PJ_STUN_IS_ERROR_RESPONSE(msg->hdr.type))
@@ -900,4 +909,5 @@
     }
 
+on_return:
     pj_mutex_unlock(sess->mutex);
 
Index: pjproject/trunk/pjlib-util/src/pjlib-util/stun_transaction.c
===================================================================
--- pjproject/trunk/pjlib-util/src/pjlib-util/stun_transaction.c	(revision 1036)
+++ pjproject/trunk/pjlib-util/src/pjlib-util/stun_transaction.c	(revision 1037)
@@ -260,5 +260,5 @@
 						 const pj_stun_msg *msg)
 {
-    pj_stun_error_code_attr *err_attr;
+    pj_stun_errcode_attr *err_attr;
     pj_status_t status;
 
@@ -282,5 +282,5 @@
 
     /* Find STUN error code attribute */
-    err_attr = (pj_stun_error_code_attr*) 
+    err_attr = (pj_stun_errcode_attr*) 
 		pj_stun_msg_find_attr(msg, PJ_STUN_ATTR_ERROR_CODE, 0);
 
@@ -301,6 +301,5 @@
 	status = PJ_SUCCESS;
     } else {
-	status = PJ_STATUS_FROM_STUN_CODE(err_attr->err_class * 100 +
-					  err_attr->number);
+	status = PJLIB_UTIL_ESTUNTSXFAILED;
     }
 
Index: pjproject/trunk/pjlib-util/src/pjstun-client/client_main.c
===================================================================
--- pjproject/trunk/pjlib-util/src/pjstun-client/client_main.c	(revision 1036)
+++ pjproject/trunk/pjlib-util/src/pjstun-client/client_main.c	(revision 1037)
@@ -30,5 +30,4 @@
     pj_timer_heap_t	*th;
     pj_stun_session	*sess;
-    unsigned		 sess_options;
     pj_sock_t		 sock;
     pj_thread_t		*thread;
@@ -46,4 +45,5 @@
     char    *user_name;
     char    *password;
+    char    *nonce;
     pj_bool_t use_fingerprint;
 } o;
@@ -181,37 +181,25 @@
     stun_cb.on_request_complete = &on_request_complete;
 
-    status = pj_stun_session_create(g.endpt, NULL, &stun_cb, &g.sess);
-    pj_assert(status == PJ_SUCCESS);
-
-    if (o.realm) {
-	pj_str_t r, u, p;
-
-	if (o.user_name == NULL) {
-	    printf("error: username must be specified\n");
-	    return PJ_EINVAL;
-	}
-	if (o.password == NULL)
-	    o.password = "";
-	g.sess_options = PJ_STUN_USE_LONG_TERM_CRED;
-	pj_stun_session_set_long_term_credential(g.sess, pj_cstr(&r, o.realm),
-						 pj_cstr(&u, o.user_name),
-						 pj_cstr(&p, o.password));
-	puts("Using long term credential");
-    } else if (o.user_name) {
-	pj_str_t u, p;
-
-	if (o.password == NULL)
-	    o.password = "";
-	g.sess_options = PJ_STUN_USE_SHORT_TERM_CRED;
-	pj_stun_session_set_short_term_credential(g.sess, 
-						  pj_cstr(&u, o.user_name),
-						  pj_cstr(&p, o.password));
-	puts("Using short term credential");
+    status = pj_stun_session_create(g.endpt, NULL, &stun_cb, 
+				    o.use_fingerprint!=0, &g.sess);
+    pj_assert(status == PJ_SUCCESS);
+
+    if (o.user_name) {
+	pj_stun_auth_cred cred;
+
+	pj_bzero(&cred, sizeof(cred));
+
+	cred.type = PJ_STUN_AUTH_CRED_STATIC;
+	cred.data.static_cred.realm = pj_str(o.realm);
+	cred.data.static_cred.username = pj_str(o.user_name);
+	cred.data.static_cred.data_type = 0;
+	cred.data.static_cred.data = pj_str(o.password);
+	cred.data.static_cred.nonce = pj_str(o.nonce);
+
+	pj_stun_session_set_credential(g.sess, &cred);
+	puts("Session credential set");
     } else {
 	puts("Credential not set");
     }
-
-    if (o.use_fingerprint)
-	g.sess_options |= PJ_STUN_USE_FINGERPRINT;
 
     status = pj_thread_create(g.pool, "stun", &worker_thread, NULL, 
@@ -276,5 +264,5 @@
 		pj_assert(rc == PJ_SUCCESS);
 
-		rc = pj_stun_session_send_msg(g.sess, g.sess_options, 
+		rc = pj_stun_session_send_msg(g.sess, PJ_FALSE, 
 					      &g.dst_addr, sizeof(g.dst_addr),
 					      tdata);
@@ -303,4 +291,5 @@
     puts(" --username, -u    Set username of the credential");
     puts(" --password, -p    Set password of the credential");
+    puts(" --nonce, -N       Set NONCE");   
     puts(" --fingerprint, -F Use fingerprint for outgoing requests");
     puts(" --help, -h");
@@ -313,4 +302,5 @@
 	{ "username",	1, 0, 'u'},
 	{ "password",	1, 0, 'p'},
+	{ "nonce",	1, 0, 'N'},
 	{ "fingerprint",0, 0, 'F'},
 	{ "help",	0, 0, 'h'}
@@ -331,4 +321,7 @@
 	    o.password = pj_optarg;
 	    break;
+	case 'N':
+	    o.nonce = pj_optarg;
+	    break;
 	case 'h':
 	    usage();
